#erase everything on the workspace
rm(list=ls())

#setting work environment
setwd("F:/Documentos/1.1.Proyectos/12. Defining shell whorl cross section/Scripts")

#loading packages
library(randomcoloR)
library(ggplot2)
library(tidyr)
library(plotly)
library(vegan)

#load data
scores_44SL_305SP<-read.csv("results/305_scores_GM_44SL.csv", sep=',',dec =".") #scores in the original sample n = 305

scores_44SL<-read.csv("results/scores_GM_44SL.csv", sep=',',dec =".") # resulting scores for 44 SL setting sample n = 50
scores_56SL<-read.csv("results/scores_GM_56SL.csv", sep=',',dec =".") # resulting scores for 56 SL setting sample n = 50
scores_FA<- read.csv("results/fourier_analysis_complete.csv", sep=',',dec =".") # resulting scores for OBA setting sample n = 50
CS<-read.csv("results/Csize_GM_56SL.csv", sep=',',dec =".") #for this evaluation we only use the CS of 56 SL as it would be the most accurate value

#New dataframes for comparisons

PC1_56<-scores_56SL$PC1
PC2_56<-scores_56SL$PC2
PC3_56<-scores_56SL$PC3


PC1_44<-scores_44SL$PC1
PC2_44<-scores_44SL$PC2
PC3_44<-scores_44SL$PC3

PC1_FA<-scores_FA$PC1
PC2_FA<-scores_FA$PC2
PC3_FA<-scores_FA$PC3

Number<-seq(1,50)


#subset of the original sample with 305 specimens to compare scores
subset_scores_44SL_305SP <- scores_44SL_305SP[c(2,4,5,9,10,13,21,24,27,30,34,49,63
                                                  ,64,67,87,96:97,105,107,110,118,123,
                                                  130,134,137,139,150,156,157,163,171,175
                                                  ,178,182,191,193,200,201,203,210,212,218
                                                  ,219,224,231,245,256,266,303),]

PC1_44_305<-subset_scores_44SL_305SP$PC1
PC2_44_305<-subset_scores_44SL_305SP$PC2
PC3_44_305<-subset_scores_44SL_305SP$PC3

                #### Preliminar evaluation of the dataset ####

#Checking that the sample is representative of the original morphospace


df0<-cbind.data.frame(Number,PC1_44,PC2_44,PC3_44,PC1_44_305,PC2_44_305,PC3_44_305)


#location of points for the subset using 44SL with respecto to the larger morphospace (n=305)
morphospace_evaluation<-ggplot(scores_44SL_305SP, 
                                aes(PC1, PC2))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.5,0.5)+ylim(-0.5,0.5)+theme_bw()
morphospace_evaluation
morphospace_evaluation+geom_point(data=df0,aes(-PC1_44, -PC2_44, color = "red", label=Number))

#Original score  (PC1 and PC2) for the specimens in the large morphospace (n=305) vs location after the evaluation of the subset
morphospace_evaluation2<-ggplot(df0, 
                         aes(PC1_44, PC2_44, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.5,0.5)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()+geom_point(aes(-PC1_44_305, -PC2_44_305, color = "red", Label=Number))
morphospace_evaluation2



cor(df0$PC1_44, df0$PC1_44_305, method = 'pearson')
cor(df0$PC2_44, df0$PC2_44_305, method = 'pearson')
cor(df0$PC3_44, df0$PC3_44_305, method = 'pearson')


      #### Comparisons between settings VMM(56SL, 44SL) vs OBA####

#Create main dataframe

df<-cbind.data.frame(Number,CS, PC1_56,PC2_56,PC3_56,PC1_44,PC2_44,PC3_44,PC1_FA,PC2_FA,PC3_FA)

#checking the disposition of the principal components

#PC1 and PC2 for 56 SL

morphospace_56SL<-ggplot(df, 
                         aes(PC1_56, PC2_56, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.5,0.5)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_56SL


#PC1 and PC3 for 56 SL

morphospace_56SL2<-ggplot(df, 
                         aes(PC1_56, PC3_56, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC3")+xlim(-0.5,0.5)+ylim(-0.2,0.2)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_56SL2

#PC1 and PC2 for 44 SL
morphospace_44SL<-ggplot(df, 
                         aes(PC1_44, PC2_44, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.5,0.5)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_44SL

#PC1 and PC3 for 44 SL
morphospace_44SL2<-ggplot(df, 
                         aes(PC1_44, PC3_44, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC3")+xlim(-0.5,0.5)+ylim(-0.2,0.2)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_44SL2

#PC1 and PC2 for OBM
morphospace_FA<-ggplot(df, 
                         aes(PC1_FA, PC2_FA, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.7,0.7)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_FA

#PC1 and PC3 for OBM
morphospace_FA2<-ggplot(df, 
                       aes(PC1_FA, PC3_FA, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC3")+xlim(-0.7,0.7)+ylim(-0.2,0.2)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_FA2

#it seems that PC1 and PC2 of the results derived from OBM are flipped, therefore
df$PC1_FA<--(df$PC1_FA)
df$PC2_FA<--(df$PC2_FA)
#PC1 and PC2 for OBM corrected disposition
morphospace_FA<-ggplot(df, 
                       aes(PC1_FA, PC2_FA, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC2")+xlim(-0.7,0.7)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_FA

#PC1 and PC3 for OBM corrected disposition

morphospace_FA2<-ggplot(df, 
                       aes(PC1_FA, PC3_FA, label=Number))+ geom_point() + 
  labs(x="PC1", y="PC3")+xlim(-0.7,0.7)+ylim(-0.5,0.5)+geom_text(hjust=0, vjust=0,size=4)+theme_bw()
morphospace_FA2

#tridimensional plots 


plot_ly(df, x = ~PC1_56, y = ~PC2_56, z = ~PC3_56, type="scatter3d", mode="markers",  size = 1.5, text= ~Number,textposition = 'middle right',
        textfont = list(color = 'grey', size = 16))

plot_ly(df, x = ~PC1_44, y = ~PC2_44, z = ~PC3_44, type="scatter3d", mode="markers",  size = 1.5, text= ~Number,textposition = 'middle right',
        textfont = list(color = 'grey', size = 16))

plot_ly(df, x = ~PC1_FA, y = ~PC2_FA, z = ~PC3_FA, type="scatter3d", mode="markers",  size = 1.5, text= ~Number,textposition = 'middle right',
        textfont = list(color = 'grey', size = 16))


# Generation of vector to perform Mantel test

# first to test PC1 and PC2

subset_56SL <- df[,4:5]
subset_56SL

subset_44SL <- df[,7:8]
subset_44SL

subset_FA <- df[,10:11]
subset_FA

#Transformation of subset to distance matrices

dist.56SL = dist(subset_56SL, method = "euclidean")
dist.56SL

dist.44SL = dist(subset_44SL, method = "euclidean")
dist.44SL

dist.FA = dist(subset_FA, method = "euclidean")
dist.FA

#Mantel test for 56SL vs 44 SL
SL56vs44 = mantel(dist.56SL, dist.44SL, method = "spearman", permutations = 9999, na.rm = TRUE)
SL56vs44

#Mantel test for 56SL vs OBA
SL56vsFA = mantel(dist.56SL, dist.FA, method = "spearman", permutations = 9999, na.rm = TRUE)
SL56vsFA

#Mantel test for 44SL vs OBA
SL44vsFA = mantel(dist.44SL, dist.FA, method = "spearman", permutations = 9999, na.rm = TRUE)
SL44vsFA

#Second for PC1, PC2 and PC3
subset_56SL2 <- df[,c(4:6)]
subset_56SL2

subset_44SL2 <- df[,c(7:9)]
subset_44SL2

subset_FA2 <- df[,c(10:12)]
subset_FA2

#Transformation of subset to distance matrices

dist.56SL2 = dist(subset_56SL, method = "euclidean")
dist.56SL2

dist.44SL2 = dist(subset_44SL, method = "euclidean")
dist.44SL2

dist.FA2 = dist(subset_FA, method = "euclidean")
dist.FA2

#Mantel test for 56SL vs 44 SL
SL56vs44_2 = mantel(dist.56SL2, dist.44SL2, method = "spearman", permutations = 9999, na.rm = TRUE)
SL56vs44_2

#Mantel test for 56SL vs OBA
SL56vsFA_2 = mantel(dist.56SL2, dist.FA2, method = "spearman", permutations = 9999, na.rm = TRUE)
SL56vsFA_2

#Mantel test for 44SL vs OBA
SL44vsFA_2 = mantel(dist.44SL2, dist.FA2, method = "spearman", permutations = 9999, na.rm = TRUE)
SL44vsFA_2


