#erase everything on the workspace
rm(list=ls())

#load packages

library(Momocs)
library(rgeos)
library(jpeg)
library (ggplot2)
library(morphospace)
#setting environment

setwd("F:/Documentos/1.1.Proyectos/12. Defining shell whorl cross section/Scripts")


#import dataset

input_folder <- "images_whorl_sections_2"
fil <- list.files(input_folder, 
                  pattern = "jpg",
                  full.names = T)

WS <- import_jpg(jpg.paths = fil, 
                 auto.notcentered=T)

#Translate whorl sections to outline Momoc files

OutWS <- Out(WS)
# Subsample all the same number of points (here 200)


cooWS <- coo_interpolate(OutWS, 
                         n=200)

# Centering and scaling (all the wp with the same orientation)

centerWS <- coo_center(cooWS)
scaleWS <- coo_scale(centerWS)

#preview of the outlines:
panel(scaleWS)
stack(scaleWS)

# to check a single outline:
coo_plot(scaleWS[2])

# Find the point of the shape nearest to vertical line starting from center 
ids <- suppressWarnings(coo_intersect_angle(scaleWS, 
                                            angle=pi/2)) 
ids


# Slide number of the coordinates so that the first point of each shape is
# homologous (i.e. the upper "tip" of the shape, defined in vector ids)
slideWS <- coo_slide(scaleWS, 
                     id=unlist(ids))

# to check the outlines:
coo_plot(slideWS[10])

# Run elliptical fourier analysis with default automatic number of harmonics
fou <- efourier(slideWS, norm=F,nb.h=6) # 6 harmonics for 99% of variance
fou
class(fou)
#amplitude of the coefficient
boxplot(fou, drop=1)
#concensus // mean shape
ms<-MSHAPES(fou)
write.csv(ms, "results/consensus_FA.csv", row.names = TRUE)
coo_plot(ms)http://127.0.0.1:43861/graphics/plot_zoom_png?width=654&height=549
df0<-cbind.data.frame(ms)

consensus<-ggplot(df0, 
                       aes(x, y))+ geom_point() + 
  labs(x="x", y="y")+theme_bw()+geom_path()
consensus

#Principal component analysis

pca <- PCA(fou)
summary(pca)


mspace(fou,axes = c(1, 2),  cex.ldm = 0.05,nv=10, nh=12, points = T,size.models = 2 )
points(pca$x[,c(1,2)], col ="black", pch = 19,cex = 1)

mspace(fou,axes = c(1, 3),  cex.ldm = 0.05,nv=10, nh=12, points = T,size.models = 2 )
points(pca$x[,c(1,3)], col ="black", pch = 19,cex = 1)

#layer_morphospace_PCA(size = 0.25,nr = 10,nc =12)%>% layer_points()  


#export PCA results
PC1f <- pca$x[,1]
PC2f <- pca$x[,2]
PC3f <- pca$x[,3]
PC4f <- pca$x[,4]
PC5f <- pca$x[,5]
PC6f <- pca$x[,6]

df<-cbind.data.frame(PC1f,PC2f,PC3f,PC4f,PC5f, PC6f)
df
write.csv(df, "results/fourier_analysis_complete.csv", row.names = TRUE)

morphospace_FA<-ggplot(df, 
                       aes(PC1f, PC2f))+ geom_point() + 
  labs(x="PC1", y="PC2")+theme_bw()
morphospace_FA


